/** 
 *主页面控制器
 * @sxy
 **/

angular.module('zhxyteacher.check_daily', ["posthelper"])

	.controller('check_daily_controller', function($scope, posthelper) {
		mui.init({
			swipeBack: true
		});

		var toDouble = function(str) { //一位数转两位数
			if(str < 10) {
				str = '0' + str
			};
			return str;
		}
		//获取当前年份和月份
		var oDate = new Date();
		var curYear = oDate.getFullYear();
		var curMonth = oDate.getMonth() + 1;
		curMonth = toDouble(curMonth);

		//获取连续签到次数
		var fSignedTimes = function() {
			var state = app.getState();
			var method = 'UserSignDays';
			var parameter = {
				"year": curYear,
				"month": curMonth
			};
			state.method = method;
			state.parameter = parameter;
			posthelper.httppost(app.serverUrl, state, function callback(backdata) {
				$scope.$apply(function() {
					console.log(JSON.stringify(backdata));
					console.log("连续签到：" + JSON.stringify(backdata));
					if(backdata.signstate == "0") {
						$scope.ischeck = "我要签到";
					} else {
						$scope.ischeck = "已签到";
					}
					$scope.signDays = backdata.days; //连续签到天数
					$scope.signMonthdays = backdata.monthdays; //月签到天数

				});
			});
		};
		//获取连续签到次数结束	
		fSignedTimes() //页面刷新时执行一次

		//将2017/4/1 0:00:00转换成20170401 以便添加签到样式
		var toDate = function(sDate) {
			var iDate = sDate.split(' ')[0].split('/');
			for(var i = 1; i < 3; i++) {
				if(iDate[i] < 10) {
					iDate[i] = '0' + iDate[i]
				};
			}
			return(iDate.join(''))
		}

		//封装签到日记函数
		var fCurrentMonthSign = function(YYYY, MM) {
			//获取签到日记的数据
			state = app.getState();
			method = 'UserSignList';
			parameter = {
				"year": YYYY,
				"month": MM
			};
			
			state.method = method;
			state.parameter = parameter;
			posthelper.httppost(app.serverUrl, state, function callback(backdata) {
				$scope.$apply(function() {
					console.log("签到列表：" + JSON.stringify(backdata));
					angular.forEach(backdata, function(data, index) {
						data.sdate = toDate(data.sdate); //将sdate转换成20170401
						if(data.imark != '') {
							$('.currentMonth').each(function(index, value) { //在当月日期里循环添加已签到样式
								if($(value).attr('date') == data.sdate) {
									$(value).addClass('signedDay');
								};
							});
						};
					});
				});
			});
		};
		//签到日记函数结束
		fCurrentMonthSign(curYear, curMonth); //页面加载完先获取当月签到数据

		//左右按钮切换月份
		var iMonth = curMonth;
		var iYear = curYear;

		$('#prevMonth').on('click', function() {
			iMonth--;
			if(iMonth == 0) {
				iMonth = 12;
				iYear--;
			};
			fCurrentMonthSign(iYear, iMonth);
		});

		$('#nextMonth').on('click', function() {
			iMonth = parseInt(iMonth) + 1;
			iYear = parseInt(iYear);
			if(iMonth == 13) {
				iMonth = 1;
				iYear++;
			};
			fCurrentMonthSign(iYear, iMonth);
		});

		//点击签到
		$scope.sign = function() {
			if($scope.ischeck == "已签到") {
				layer.msg("您已签到", {
					icon: 0
				})
			} else {
				//提交签到数据
				state = app.getState();
				method = 'UserSign';
				parameter = {};
				state.method = method;
				state.parameter = parameter;
				posthelper.httppost(app.serverUrl, state, function callback(backdata) {
					$scope.$apply(function() {
						console.log("签到结果：" + JSON.stringify(backdata));
						$scope.signData = backdata; //获取签到响应 成功ok 失败error
						if(backdata.type == "ok") {
							layer.msg("签到成功", {
								icon: 1
							});
							location.reload(true);
						} else {
							layer.msg("签到失败", {
								icon: 0
							});
						}
					});
				});
				fCurrentMonthSign(curYear, curMonth); //刷新签到日记到当前月份
				fSignedTimes(); //重新获取连续签到数据
			}

		};
		$scope.openScore = function(){
			clicked('../main/complain.html',true,false,{title:"积分说明",targeturl:app.baseUrl+"/upload/explain/explain.html"});
		}
	})
	.filter("replaceslash", function() {
		return function(input) {
			var out = "";
			return input.replace("/", "");
		}
	})
	.config(function($compileProvider) {
		$compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|javascript):/);
	});