/** 
 *主页面控制器
 * @sxy
 **/

angular.module('zhxyteacher.registration', ["posthelper"])

	.controller('registration_controller', function($scope, posthelper) {
		mui.init({
			swipeBack: true
		});
		$scope.phone = "";
		$scope.pwd = "";
		$scope.confirmpwd = "";
		$scope.code = "";
		$scope.codestate = true;
		$scope.getcodevalue = "获取短信验证码"
		$scope.wait = 60;

		var state = app.getState();
		//获取验证过吗
		$scope.getCode = function() {
			if(!$scope.codestate) {
				alert('请倒计时结束后，重新获取');
				return false;
			}
			//获取手机号，验证手机号格式
			//			var myreg = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1}))+\d{8})$/;
			var myreg = /^([0-9]{11})$/;
			if(!myreg.test($scope.phone)) {
				alert('请输入有效的手机号码！');
				return false;
			}
			if(escape($scope.pwd).indexOf("%u") >= 0) {
				alert('密码不能包含中文');
				return false;
			}
			if($scope.pwd.trim() == "" || $scope.pwd.trim().length < 6) {
				alert('密码不能为空且长度不能小于6位');
				return false;
			}
			if($scope.confirmpwd.trim() == '' || $scope.pwd.trim() != $scope.confirmpwd.trim()) {
				alert('两次输入的密码不相同');
				return false;
			}
			var method = 'GetVerification';
			var parameter = {
				iphone: $scope.phone,
				pwd: $scope.pwd
			};
			state.method = method;
			state.parameter = parameter;
			posthelper.httppost(app.serverUrl, state, function callback(backdata) {
				$scope.$apply(function() {
					console.log(JSON.stringify(backdata));
					if(backdata.type == 'ok') {
						mui.toast("获取验证码成功")
						//获取成功后，将获取按钮置为不可点击，60秒后可以点击重新获取。
						$scope.codestate = false;
						$scope.time();
					} else {
						mui.toast(backdata.msg)
					}
				});
			});
		}
		$scope.time = function() {
			if($scope.wait == 0) {
				document.getElementById("getcodevalue").innerHTML = "获取验证码"
				$scope.wait = 60;
				$scope.codestate = true;
			} else {
				//				$scope.getcodevalue =
				document.getElementById("getcodevalue").innerHTML = "重新获取(" + $scope.wait + ")";
				$scope.wait--;
				setTimeout(function() {
						$scope.time()
					},
					1000)
			}
		}
		//注册
		$scope.regist = function() {
			//获取手机号，验证手机号格式
			//			var myreg = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1}))+\d{8})$/;
			var myreg = /^([0-9]{11})$/;
			if(!myreg.test($scope.phone)) {
				alert('请输入有效的手机号码！');
				return false;
			}
			if($scope.pwd.trim() == "" || $scope.pwd.trim().length < 6) {
				alert('密码不能为空且长度不能小于6位');
				return false;
			}
			if($scope.confirmpwd.trim() == '' || $scope.pwd.trim() != $scope.confirmpwd.trim()) {
				alert('两次输入的密码不相同');
				return false;
			}
			var method = 'GetRegister';
			var parameter = {
				iphone: $scope.phone,
				code: $scope.code
			};
			state.method = method;
			state.parameter = parameter;
			posthelper.httppost(app.serverUrl, state, function callback(backdata) {
				$scope.$apply(function() {
					console.log(JSON.stringify(backdata));
					if(backdata.type == 'ok') {
						mui.toast("注册成功");
						//登录
						var deviceid = app.getState().head.ucode;
						var method = 'GetLand';
						var parameter = {
							iphone: $scope.phone,
							pwd: $scope.pwd.trim()
						};
						state.method = method;
						state.parameter = parameter;
						posthelper.httppost(app.serverUrl, state, function callback(backdata) {
							$scope.$apply(function() {
								console.log(JSON.stringify(backdata));
								if(backdata.token != undefined && backdata.token != '') {
									//创建state
									app.createState('', '', '', backdata.token, deviceid);
									app.setParameter("phone", $scope.phone);
									var all = plus.webview.all();
									for(var i = 0; i < all.length; i++) {
										if(all[i].id == "regist") {
											all[i].close();
										} else if(all[i].id == "registration") {
											all[i].close();
										} else if(all[i].id == "login") {
											all[i].close();
										}
									}
									var reward_report = plus.webview.getWebviewById("main");
									mui.fire(login, 'refreshlist');
									app.openWindow('main', 'main.html');
								} else {
									mui.toast('用户名或密码错误');
								}
							});
						});
					} else {
						mui.toast('注册失败，请重新注册')
					}
				});
			});
		}

	})
	.filter("replaceslash", function() {
		return function(input) {
			var out = "";
			return input.replace("/", "");
		}
	})
	.config(function($compileProvider) {
		$compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|javascript):/);
	});