/** 
 *主页面控制器
 * @sxy
 **/

angular.module('zhxyteacher.reward_report_map', ["posthelper"])

	.controller('reward_report_map_controller', function($scope, posthelper) {
		mui.init({
			swipeBack: true
		});
		var rewardid = app.getParameter("rewardid");
		var type = app.getParameter("type");
		var ws = null,
			wo = null;
		var em = null,
			map = null,
			pcenter = null;
		// H5 plus事件处理
		if(window.plus) {
			plusReady();
		} else {
			document.addEventListener("plusready", plusReady, false);
		}
		//请求数据
		function plusReady() {
			var methods = "";
			if(type == "1") {
				methods = "GetReportDetail";
			} else {
				methods = "GetVehicleDetail";
			}
			var state = app.getState();
			var parameter = {
				id: rewardid
			};
			state.method = methods;
			state.parameter = parameter;
			posthelper.httppost(app.serverUrl, state, function callback(backdata) {
				$scope.$apply(function() {
					var longitude = backdata.longitude;
					var latitude = backdata.latitude;
					var Collection;
					if(type == "2") {
						Collection = backdata.LicenseNO;
					} else {
						Collection = backdata.Collection;
					}
					map_init(longitude, latitude, Collection);
				});
			});
		}

		function map_init(longitude, latitude, Collection) {
			if(!em || ws) {
				return
			};
			// 获取窗口对象
			ws = plus.webview.currentWebview();
			wo = ws.opener();
			pcenter = new plus.maps.Point(longitude, latitude);
			setTimeout(function() {
				map = new plus.maps.Map("map");
				map.centerAndZoom(pcenter, 12);
				createMarker(longitude, latitude, Collection);
			}, 300);                      
		}

		function createMarker(longitude, latitude, Collection) {
			//高德地图坐标为(116.3406445236,39.9630878208), 百度地图坐标为(116.347292,39.968716
			if(longitude == null) {
				plus.geolocation.getCurrentPosition(geoInf, function(e) {
					outSet("获取定位位置信息失败：" + e.message);
				}, {
					geocode: true,
					provider: 'amap'
				});
				if(!em || ws) {
					return
				};

				// 显示页面并关闭等待框
				ws.show("pop-in");
			} else {
				var marker = new plus.maps.Marker(new plus.maps.Point(longitude, latitude));
				marker.setIcon("../../images/oneicon.png");
				marker.setLabel(Collection);
				var bubble = new plus.maps.Bubble(Collection);
				marker.setBubble(bubble);
				map.addOverlay(marker);
			}
		}

		function geoInf(position) {
			var codns = position.coords; //获取地理坐标信息；
			lat = codns.latitude; //获取到当前位置的纬度；
			longt = codns.longitude; //获取到当前位置的经度
			adrr = position.addresses;
			// 获取窗口对象
			ws = plus.webview.currentWebview();
			wo = ws.opener();
			//高德地图坐标为(116.3974357341,39.9085574220), 百度地图坐标为(116.3975,39.9074)
			pcenter = new plus.maps.Point(longt, lat);
			setTimeout(function() {
				map = new plus.maps.Map("map");
				map.centerAndZoom(pcenter, 12);
				createMarkers();
				// 创建子窗口
			}, 300);
		}

		function createMarkers() {
			//高德地图坐标为(116.3406445236,39.9630878208), 百度地图坐标为(116.347292,39.968716
			var marker = new plus.maps.Marker(new plus.maps.Point(longt, lat));
			map.addOverlay(marker);
		}
		// DOMContentloaded事件处理
		document.addEventListener("DOMContentLoaded", function() {
			em = document.getElementById("map");
			window.plus && plusReady();
		}, false);

	})
	.filter("replaceslash", function() {
		return function(input) {
			var out = "";
			return input.replace("/", "");
		}
	})
	.config(function($compileProvider) {
		$compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|javascript):/);
	});