/** 
 *主页面控制器
 * @sxy
 **/

angular.module('zhxyteacher.night_construction', ["posthelper"])

	.controller('night_construction_controller', function($scope, posthelper) {
		mui.init({
			swipeBack: true
		});
		if(window.plus) {
			plusReady();
		} else {
			document.addEventListener("plusready", plusReady, false);
		}
		var ws = null,
			wo = null;
		var em = null,
			map = null,
			pcenter = null;
		// H5 plus事件处理
		function plusReady() {
			//请求数据
			var state = app.getState();
			var method = "GetCoordinate";
			var parameter = {
				pageIndex: 1,
				pageSize: 100
			};
			state.method = method;
			state.parameter = parameter;
			posthelper.httppost(app.serverUrl, state, function callback(backdata) {
				$scope.$apply(function() {
					console.log(JSON.stringify(backdata));
					var markerArr = [];
					angular.forEach(backdata, function(item, index) {
						if(item.longitude.length > 0) {
							var place = item.ConPlaceName;
							if(place.length >5){
								place = place.substr(0,5)+"..";
							}
							var marker = {
								jd: item.longitude,
								wd: item.latitude,
								place: place,
								id: item.id
							}
							markerArr.push(marker);
						}

					});
					$scope.markernum=markerArr.length;
					map_init(markerArr);
				});
			});
		}

		function map_init(markerArr) {
			if(!em || ws) {
				return
			};
			// 获取窗口对象
			ws = plus.webview.currentWebview();
			wo = ws.opener();
			pcenter = new plus.maps.Point(120.409, 36.0654);
			map = new plus.maps.Map("map");
			map.centerAndZoom(pcenter, 12); 
			for (var  i  =  0;  i  <  markerArr.length;  i++)  {                          
				var  p0  =  markerArr[i].jd; 
				if(p0.length > 0) {
					var  p1  =  markerArr[i].wd;  
					var place = markerArr[i].place;
					var id = markerArr[i].id;
					var  maker  =  addMarker(new plus.maps.Point(p0, p1), place, id); 
				}                                                
			}  
			// 显示页面并关闭等待框
			ws.show("pop-in");
		}

		function addMarker(point, place, id) {
			var marker = new plus.maps.Marker(point);
			marker.setIcon("../../images/oneicon.png");
			marker.setLabel(place);
			marker.id = id;
			marker.onclick = function(marker) {
				var areaid = marker.id; //公示id
				console.log("marker.id--"+marker.id);
				app.setParameter('areaid', areaid);
				app.setParameter("areatype", 'GetConstruction');
				app.openWindow("approval_publicity", "../main/approval_publicity.html");
			}
			map.addOverlay(marker);
			return  marker;  
		}
		// DOMContentloaded事件处理
		document.addEventListener("DOMContentLoaded", function() {
			em = document.getElementById("map");
			window.plus && plusReady();
		}, false);

	})
	.filter("replaceslash", function() {
		return function(input) {
			var out = "";
			return input.replace("/", "");
		}
	})
	.config(function($compileProvider) {
		$compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|javascript):/);
	});