/** 
 *主页面控制器
 * @sxy
 **/

angular.module('zhxyteacher.air_quality_calendar', ["posthelper"])

	.controller('air_quality_calendar_controller', function($scope, posthelper) {
		mui.init({
			swipeBack: true
		});
        //获取当前日期
		var oDate = new Date();
		var realYear = oDate.getFullYear();
		var realMonth = oDate.getMonth() + 1;
		var realDay = oDate.getDate();

		var yearNow = realYear;
		var monthNow = realMonth;
		var dayNow = realDay;
		//获取月函数
		function getMonth(YYYY, M) {
			var state = app.getState();
			var  head= {
		        appkey: 1,
				angent: 2,
				userid: 3,
				token: 4
		    };
			var method = 'GetMonth';
			var parameter = {
				"iMonth": M,
				"iyear": YYYY
			};
			state.head=head;
			state.method = method;
			state.parameter = parameter;
			posthelper.httppost(app.serverUrl, state, function callback(backdata) {
				$scope.$apply(function() {
					console.log("日历数据："+JSON.stringify(backdata));
					var result = backdata;
					myAddClass(result);
				});
			});
		}
		getMonth(yearNow, monthNow); //页面刷新先获取一次月份信息

		//获取年函数
		function getYear(YYYY) {
			var state = app.getState();
			var method = 'GetDQ_Cod_City';
			var parameter = {
				"iyear": YYYY
			};
			state.method = method;
			state.parameter = parameter;
			posthelper.httppost(app.serverUrl, state, function callback(backdata) {
				$scope.$apply(function() {
					console.log(JSON.stringify(backdata));
					var result = backdata;
					myAddClass(result);
				});
			});
		}

		//根据等级给每个日期添加不同样式的函数
		function myAddClass(result) {
			var $aTd = $('td[class^=currentMonth]');

			angular.forEach(result, function(item) {
				var idate = item.iYear + toDouble(item.iMonth) + toDouble(item.iDay); //转换成20170302格式
				$.each($aTd, function(index, td) {
					if($(this).attr("date") == idate) {
						if(item.CityAQI24Lvl == "一级") { $(this).addClass('quality1') } else if(item.CityAQI24Lvl == "二级") { $(this).addClass('quality2') } else if(item.CityAQI24Lvl == "三级") { $(this).addClass('quality3') } else if(item.CityAQI24Lvl == "四级") { $(this).addClass('quality4') } else if(item.CityAQI24Lvl == "五级") { $(this).addClass('quality5') }
					}
				})
			});
		}


		//一位数转两位数
		function toDouble(num) {
			if(num < 10) {
				return '0' + num;
			};
			return num + '';
		};

		//标题显示当前年月信息
		var strYear = $('.calendar-title-box-right').html();
		$('.center-text').html(strYear);
		$('.calendar-title-box').addClass('none')

		var $btnYear = $('.btnYear');
		var $btnMonth = $('.btnMonth');
        
		var b = true; //控制按钮是否能点击的布尔值

		$btnYear.on('click', function() {
			if(!b) { return false } //当前按钮是被点击状态，则不执行
			yearNow = realYear;
			monthNow = realMonth;
			$(this).addClass('active');
			$btnMonth.removeClass('active');
			$('#myCalendar').toggleClass('none'); //切换按钮样式

			for(var i = 0; i < 12; i++) {
				$('<div class="CalendarAll" id="myCalendar' + i + '"></div>').appendTo($('.parent'));
				renderHtml('myCalendar' + i);
				var date = dateObj.getDate();
				console.log(date.getFullYear())
				dateObj.setDate(new Date(yearNow, i, 1));
				showCalendarData('myCalendar' + i);
			}; //创建出12个月份

			$('#prevMonth,#nextMonth').unbind(); //先解除事件

			var $center_text = $('.center-text');
			$center_text.html(yearNow) //标题显示当前年份
			$('#prevMonth').on('click', function() {
				yearNow--;
				createYear(yearNow)
				$center_text.html(yearNow) //标题显示当前年份
				getYear(yearNow); //获取当前年份的污染信息
			}); //添加上一年按钮事件

			$('#nextMonth').on('click', function() {
				yearNow++;
				createYear(yearNow);
				$center_text.html(yearNow) //标题显示当前年份
				getYear(yearNow); //获取当前年份的污染信息
			}); //添加下一年按钮事件

			getYear(yearNow); //点击"年"之后获取当年的污染信息
			b = false;
		});

		function createYear(year) {
			for(var i = 0; i < 12; i++) {
				var date = dateObj.getDate();
				dateObj.setDate(new Date(year, i, 1));
				showCalendarData('myCalendar' + i);
			};
		};

		$btnMonth.on('click', function() {
			if(b) { return false };
			console.log($('#prevMonth')[0].onclick)
			yearNow = realYear;
			monthNow = realMonth;
			$('.CalendarAll').remove(); //删除

			$(this).addClass('active');
			$btnYear.removeClass('active');
			$('#myCalendar').toggleClass('none');
			$('.center-text').html(strYear); //标题显示当前年月

			$('.prevMonth,.nextMonth').unbind(); //先解除事件

			$('.prevMonth').on('click', function() {
				monthNow--;
				if(monthNow == 0) { monthNow = 12;
					yearNow-- }
				getMonth(yearNow, monthNow);
			}) //点击上一月按钮

			$('.nextMonth').on('click', function() {
				monthNow++;
				if(monthNow == 13) { monthNow = 1;
					yearNow++ }
				getMonth(yearNow, monthNow);
			}) //点击下一月按钮

			dateObj.setDate(new Date(yearNow, monthNow - 1, 1));
			//重置日期到当前月份
			showCalendarData('myCalendar');
			getMonth(yearNow, monthNow); //点击"月"之后获取当月的污染信息

			b = true;
		});
		
		$('.prevMonth').on('click', function() {
				monthNow--;
				if(monthNow == 0) { monthNow = 12;
					yearNow-- }
				getMonth(yearNow, monthNow);
			}) //点击上一月按钮

			$('.nextMonth').on('click', function() {
				monthNow++;
				if(monthNow == 13) { monthNow = 1;
					yearNow++ }
				getMonth(yearNow, monthNow);
			}) //点击下一月按钮
		
	})
	.filter("replaceslash", function() {
		return function(input) {
			var out = "";
			return input.replace("/", "");
		}
	})
	.config(function($compileProvider) {
		$compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|javascript):/);
	});