/** 
 *主页面控制器
 * @sxy
 **/

angular.module('zhxyteacher.air_quality_map', ["posthelper"])

	.controller('air_quality_map_controller', function($scope, posthelper) {
		mui.init({
			swipeBack: true
		});
		//请求数据
		var markerArrs = [];
		var state = app.getState();
		var method = "GetAqiStation";
		var parameter = {};
		state.method = method;
		state.parameter = parameter;
		mui.ajax(app.serverUrl, {
			data: JSON.stringify(state),
			dataType: 'text',
			type: 'post',
			timeout: 10000,
			async: false,
			success: function(data) {
				console.log("宿舍：" + JSON.stringify(data));
				var back = JSON.parse(data);
				datas = back.result;
				var markerArr = [];
				angular.forEach(datas, function(item, index) {
					var marker = {
						jd: item.GIS_LONGTITUDE,
						wd: item.GIS_LATITUDE,
						aqi: item.AQI
					}
					markerArr.push(marker);
					markerArrs = markerArr;
				});
			}
		});
		// 百度地图API功能
		var map = new BMap.Map("allmap");
		var point = new BMap.Point(120.409, 36.0654);
		map.centerAndZoom(point, 9);
		// 编写自定义函数,创建标注
		function addMarker(point, aqi) {
			var opts = {
				position: point, // 指定文本标注所在的地理位置
//				offset: new BMap.Size(30, -30) //设置文本偏移量
			}
			var label = new BMap.Label(aqi, opts); // 创建文本标注对象
			var colorstr="";
			var textcolor="";
			var AQI=parseInt(aqi);
			if(AQI <= 50) {
				colorstr = "#01e50c";
				textcolor="#000";
			} else if((AQI >= 51) && (AQI <= 100)) {
				colorstr = "#fdbd33";
				textcolor="#000";
			} else if((AQI >= 101) && (AQI <= 150)) {
				colorstr = "#ff8000";
				textcolor="#000";
			} else if((AQI >= 151) && (AQI <= 200)) {
				colorstr = "#ea3232";
				textcolor="#fff";
			} else if((AQI >= 201) && (AQI <= 300)) {
				colorstr = "#950044";
				textcolor="#fff";
			} else if(AQI > 300) {
				colorstr = "#7c0227";
				textcolor="#fff";
			}
			label.setStyle({
				  width:'40px',
				  height:'28px',
				  lineHeight: '28px',
				  border:"0px",
				  fontSize:"16px",
				  borderRadius: '4px',
				  boxShadow: '0 0 4px #777',
				  marginBottom: '10px',
				  textAlign: 'center',
				  background: colorstr, 
				  color: textcolor
			});
			map.addOverlay(label);
			return label;
		}
		// 随机向地图添加25个标注
		for(var i = 0; i < markerArrs.length; i++) {
			var point = new BMap.Point(markerArrs[i].jd, markerArrs[i].wd);
			addMarker(point, markerArrs[i].aqi);
		}

	})
	.filter("replaceslash", function() {
		return function(input) {
			var out = "";
			return input.replace("/", "");
		}
	})
	.config(function($compileProvider) {
		$compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|javascript):/);
	});