/**
 * 应用相关信息配置
 **/
(function($, owner) {
	/**
	 * 项目名
	 **/
	owner.baseUrl = "http://218.58.63.45:8080";
	owner.serverUrl = owner.baseUrl + "/HbData.ashx";
	owner.appname = "huanbaoapp";
	//检查版本地址
	owner.updateUrl = "https://rd.chinags.com.cn/AutoUpdate.aspx";

	/**
	 * 创建登录状态
	 */
	var osname = "";
	owner.createState = function(appkey, angent, userid, token,deviceid) {
		var state = owner.getState();
		var head = {
			appkey: appkey,
			angent: angent,
			userid: userid,
			token: token,
			ucode: deviceid
		}
		state.head = head;
		owner.setState(state);
	};

	/**
	 * 创建当前登录用户信息
	 * @param {Object} name
	 * @param {Object} people
	 * @param {Object} callback
	 */
	owner.createUserinfo = function(UserID, UserPwd) {
		var userinfo = owner.getUserinfo();
		userinfo.UserID = UserID;
		userinfo.UserPwd = UserPwd;
		owner.setUserinfo(userinfo);
	};

	/**
	 * 设置当前登录状态
	 * @param {Object} state
	 */
	owner.setState = function(state) {
		var state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
	}
	/**
	 * 获取登录状态
	 */
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	}

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = localStorage.getItem('$settings') || "{}";
		return JSON.parse(settingsText);
	}

	/**
	 * 设置当前用户信息
	 * @param {Object} state
	 */
	owner.setUserinfo = function(userinfo) {
		var userinfo = userinfo || {};
		localStorage.setItem('$userinfo', JSON.stringify(userinfo));
	}

	/**
	 * 获当前用户信息
	 */
	owner.getUserinfo = function() {
		var userinfoText = localStorage.getItem('$userinfo') || "{}";
		return JSON.parse(userinfoText);
	}
	/**
	 * 设置当前用户权限信息
	 * @param {Object} state
	 */
	owner.setUserAuth = function(userauth) {
		var userauth = userauth || {};
		localStorage.setItem('$userauth', JSON.stringify(userauth));
	}
	/**
	 * 获当前用户权限信息
	 */
	owner.getUserAuth = function() {
		var userauthText = localStorage.getItem('$userauth') || "{}";
		return JSON.parse(userauthText);
	}
	/**
	 * 打开新页面
	 * @param {Object} id
	 * @param {Object} weburl
	 */
	owner.openWindow = function(id, weburl) {
		mui.openWindow({
			id: id,
			url: weburl,
			waiting: {
				autoShow: false
			}
		});

	}
	owner.openWindowNoloading = function(id, weburl) {
		mui.openWindow({
			id: id,
			url: weburl,
			waiting: {
				autoShow: false
			}
		});

	}
	/**
	 * 页面传值设置参数
	 * @param {Object} name
	 * @param {Object} value
	 */
	owner.setParameter = function(name, value) {
		var localvalue = value || {};
		localStorage.setItem('$' + name, JSON.stringify(value));
	};
	/**
	 * 获取页面传值的参数值
	 * @param {Object} name
	 */
	owner.getParameter = function(name) {
		var returnvalue = localStorage.getItem('$' + name) || "{}";
		return JSON.parse(returnvalue);
	}
}(mui, window.app = {}));