 /**
  *post请求工具类
  *利用mui的ajax请求
  **/
 mui.ajaxSettings.beforeSend = function(xhr, setting) {
 	xhr.setRequestHeader("Content-type", "application/json; charset=utf-8");
 	console.log('beforeSend:::' + JSON.stringify(setting));
 }; 

 angular.module('posthelper', [])
 	.factory('posthelper', function() {
 		var factory = {};
 		var index;
 		var i = 0;
 		factory.httppost = function(posturl, parameters, callback) {
 			console.log("请求次数1:"+i);
 			var onError = function(errcode) {
 				switch(errcode) {
 					case 'FAILED_NETWORK':
 						//layer.close(index);
		 				layer.msg('网络不畅,请检测网络设置',{
		 				icon:0
		 		    	});
 						break;
 					case 'FAILED_SERVER':
 						//layer.close(index);
 						layer.msg('加载失败，请稍后重试或重新加载...',{
		 				icon:0
		 		    	});
 						break;
 					case 'INVALID_TOKEN':
 						//layer.close(index);
 						//wv_login.show(); 返回登陆页
 						break;
 					default:
 						mui.toast(errcode);
 				}
 			};
 			return mui.ajax(posturl, {
 				data: JSON.stringify(parameters),
 				dataType: 'text',
 				type: 'post',
 				timeout: 10000,
 				success: function(data, status, xhr) {
 					i--;
 					console.log("请求次数2:"+i);
 					if(i == 0) {
 						//layer.close(index);
 					}
 					var back = JSON.parse(data);
 					if(back.Error == undefined) {
 						var result = back.result;
 						return callback(result);
 					} else {
 						onError(back.Error);
 						return;

 					}

 				},
 				error: function(xhr, type, errorThrown) {
 					console.log(xhr + ":" + type + ":" + errorThrown)
 					i--;
 					if(i == 0) {
 						//layer.close(index);
 					}
 					if(type == "timeout") {
 						onError('FAILED_NETWORK');
 					} else {
 						onError('FAILED_SERVER');
 					}
 					return;
 				}
 			});
 		}

 		factory.httppostloading = function(posturl, parameters, loading, callback) {
 			//console.log("请求次数"+i++);
 			var onError = function(errcode) {
 				switch(errcode) {
 					case 'FAILED_NETWORK':
 						mui.toast('连接超时,请尝试重新连接');
 						break;
 					case 'FAILED_SERVER':
 						mui.toast('服务异常，请联系管理员');
 						break;
 					case 'INVALID_TOKEN':
 						//wv_login.show(); 返回登陆页
 						break;
 					default:
 						mui.toast(errcode);
 				}
 			};
 			loading.show({
 				template: '数据加载中...'
 			});
 			return mui.ajax(posturl, {
 				data: JSON.stringify(parameters),
 				dataType: 'text',
 				type: 'post',
 				timeout: 10000,
 				success: function(data, status, xhr) {
 					loading.hide();
 					var back = JSON.parse(data);
 					if(back.Error == undefined) {
 						var result = back.result;
 						return callback(result);

 					} else {
 						onError(back.Error);
 						return;

 					}
 				},
 				error: function(xhr, type, errorThrown) {
 					console.log(xhr + ":" + type + ":" + errorThrown)
 					loading.hide();
 					if(type == "timeout") {
 						onError('FAILED_NETWORK');
 					} else {
 						onError('FAILED_SERVER');
 					}
 					return;
 				}
 			});
 		}
 		factory.show = function(loading) {
 			return loading.show({
 				template: 'Loading...'
 			});
 		}
 		factory.hide = function(loading) {
 			return loading.hide();
 		}
 		return factory;
 	});
