/**
 *post请求工具类
 *利用mui的ajax请求
 **/
mui.ajaxSettings.beforeSend = function(xhr, setting) {
	xhr.setRequestHeader("Content-type", "application/json; charset=utf-8");
	console.log('beforeSend:::' + JSON.stringify(setting));
};

angular.module('posthelper', [])
	//简洁post
	.factory('posthelper', function() {
		var factory = {};

		factory.httppost = function(posturl, parameters, callback) {
			var index;
			layer.ready(function() {
				index = layer.load(1, {
					shade: [0.8, '#393D49']
				});
			});
			if(navigator.onLine) { //正常工作
			} else { //执行离线状态时的任务
				layer.ready(function() {
 				layer.msg("网络已断开，请检测网络设置", {
 					icon: 0
 				});
 			});
			}
			var onError = function(errcode) {
				switch(errcode) {
					case 'FAILED_NETWORK':
						layer.close(index);
						layer.msg('网络不畅,请检测网络设置', {
							icon: 0
						});
						break;
					case 'FAILED_SERVER':
						layer.close(index);
						layer.msg('加载失败，请稍后重试或重新加载...', {
							icon: 0
						});
						break;
					case 'INVALID_TOKEN':
						layer.close(index);
						//wv_login.show(); 返回登陆页
						break;
					default:
						mui.toast(errcode);
				}
			};
			return mui.ajax(posturl, {
				data: JSON.stringify(parameters),
				dataType: 'text',
				type: 'post',
				timeout: 15000,
				success: function(data, status, xhr) {
					layer.close(index);
					var back = JSON.parse(data);
					if(back.Error == undefined) {
						var result = back.result;
						return callback(result);
					} else {
						onError(back.Error);
						return;

					}
				},
				error: function(xhr, type, errorThrown) {
					layer.close(index);
					console.log(xhr + ":" + type + ":" + errorThrown)
					if(type == "timeout") {
						onError('FAILED_NETWORK');
					} else {
						onError('FAILED_SERVER');
					}
					return;
				}
			});
		}
		return factory;
	});